package minicollection;

public abstract class AbstractMiniSequenceIterator<E> 
					extends AbstractMiniIterator<E>
					implements IMiniSequenceIterator<E> {
	
		
	AbstractMiniSequenceIterator(E current) {
		super(current);
	}
	
	public final void removeCurrent() {
		primitive_removeCurrent();
		setCurrent(null);
	}
	   	
	public final void previous() {
		setCurrent(primitive_previous());
		
	}
	
	protected abstract void primitive_removeCurrent();
	
	protected abstract E primitive_previous();}
