package minicollection;

public interface IFactoryMiniSequence<E> extends IFactoryMiniCollection<E> {
	
	IMiniSequence<E> makeSequence();
	
	IMiniSequence<E> makeSequence(AccessMode accessMode);
	
	IMiniSequence<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection);
	
	IMiniSequence<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection,
			AccessMode accessMode);
	
	IMiniSequence<E> makeSequence(E e, int n);
	
	IMiniSequence<E> makeSequence(E e, int n, AccessMode accessMode);
	
	
	
}