package minicollection;


public interface IMiniBagPairsImplementation<K,V> 
				extends IMiniCollectionImplementation<IMiniKeyValuePair<
							IMiniKeyValuePair<K,V>,Integer>> {

	InsertCheck implAdd(K key, V value);
	
	boolean implRemoveOnePair(K key, V value);
	
	boolean implRemove(K key);
	
	boolean implRemoveAllPair(K key, V value);
	
	boolean implContainsPair(K key, V value);
	
	int implCountPair (K key, V value);
	
	int implUniqueKeySize(); // number of unique keys
	
	int implUniqueKeyValuePairSize(); // number of unique pairs
	
	IMiniSequence<K> implGetKeys();
	
	IMiniSequence<IMiniKeyValuePair<V,Integer>> implGetValuesAndCounts(K key);
	
	IMiniSequence<V> implGetValues(K key);
	
	IMiniSequence<IMiniKeyValuePair<IMiniKeyValuePair<K, V>, Integer>>
					implGetKeyValuePairsAndCounts();
		
	// probably want to change to a set when I actually have one
	IMiniSequence<IMiniKeyValuePair<K,V>> implGetKeyValuePairs();
	
	void implRemoveDuplicateKeys();
	
	// Iteration
	IMiniBagPairsIterator<K,V> implBagIterator(); 
	
	
}
