package minicollection;

public interface IMiniBagSinglesImplementation<K> 
						extends IMiniCollectionImplementation<IMiniKeyValuePair<K,Integer>> {

	InsertCheck implAdd(K key);

	boolean implRemoveOne(K key);
	
	boolean implRemoveAll(K key);
	
	int implUniqueKeySize();
	
	IMiniSequence<K> implGetKeys();

	IMiniSequence<IMiniKeyValuePair<K, Integer>> implGetKeysAndCounts();
	
	IMiniBagSinglesIterator<K> implBagIterator();
	
}
