package minicollection;

/**
 * Implementing this interface means that an object can provide an IMiniIterator<T>.
 * 
 * @author jah217
 *
 */
public interface IMiniIterable <T> {
	
	/**
	 * Return an IMiniIterator over a collection of elements of type T.
	 * 
	 * @return an IMiniIterator.
	 */
	IMiniIterator<T> miniIterator();
	
	
}
