package minicollection;

import java.util.Iterator;

public class ImplJCIteratorAdaptor<E> extends AbstractMiniIterator<E> {
	
	Iterator<E> adaptee;
		
	public ImplJCIteratorAdaptor(Iterator<E> it, E current) {
		super(current); // set to not enforcing uniqueness
		this.adaptee = it;
	}
	
	public boolean hasNext() { return adaptee.hasNext(); } 
	
	// if there is no next this will do exactly what we want it to anyway
    protected E primitive_next() { 
    	E e = null;
    	if (adaptee.hasNext()) e = adaptee.next();
    	return e;
    }
        
    
 }
