package minicollection;

public abstract class AbstractMiniBagSinglesIterator<K>
					extends AbstractMiniIterator<IMiniKeyValuePair<K,Integer>>
					implements IMiniBagSinglesIterator<K> {
	
	AbstractMiniBagSinglesIterator(IMiniKeyValuePair<K,Integer> current) {
		super(current);
	}
	
	
	public final void removeCurrent() {
		primitive_removeCurrent();
		setCurrent(null);
	}
	   	
	
	protected abstract void primitive_removeCurrent();
	
}