package minicollection;

import java.util.Iterator;


public abstract class AbstractMiniFixedMembershipCollection<E> 
	implements IMiniBasicCollection<E> {
	
	private IMiniCollection<E> collection = null;
	
	// constructor
	AbstractMiniFixedMembershipCollection (IMiniCollection<E> collection) {
		this.collection = collection;
	}
	
	
	public boolean contains(Object element) {
		return collection.contains(element);
	}

	
	public int count(Object element) {
		return collection.count(element);
	}

	
	public boolean isEmpty() {
		return collection.isEmpty();
	}

	
	public int size() {
		return collection.size();
	}

	public Iterator<E> iterator() {
		return collection.iterator();
	}

	
	public IMiniIterator<E> miniIterator() {
		return collection.miniIterator();
	}

	// Interrogation operations
	public MembershipMode getMembershipMode() { 
		return collection.getMembershipMode();}
	
}
