package minicollection;

public abstract class AbstractMiniIterator<E> implements IMiniIterator<E>{
	
	
	private E current;

	AbstractMiniIterator(E current) {
		this.current = current;
	}

	public E current() { return current; }
	
	protected void setCurrent(E c) {current = c; }
	
	public final void next() {
		current = primitive_next();
	}
	
	protected abstract E primitive_next();
	
}
