package minicollection;


public class FactoryJCAdaptorMiniBagSingles<K> 
			implements IFactoryAdaptorMiniBagSingles<K> {
	
	
	public IMiniBagSinglesImplementation<K> makeBagSinglesAdaptor() {
		return new ImplJCBagSinglesHashMapAdaptor<K>();
		
	}
	
	// does this make sense?
	public IMiniBagSinglesImplementation<K> makeBagSinglesAdaptor(
			IMiniBagSingles<? extends K> anotherSinglesBag) {
		IMiniBagSinglesImplementation<K> adaptor = 
			new ImplJCBagSinglesHashMapAdaptor<K>();
		
		addToBag(anotherSinglesBag, adaptor); // use static to capture ?
		
		return adaptor;
		
	}
	
	
	private static <K> void addToBag(IMiniBagSingles<K> anotherSinglesBag, 
			IMiniBagSinglesImplementation<? super K> adaptor) {
		for (IMiniKeyValuePair<K,Integer> pair : anotherSinglesBag) {
			
			Integer count = pair.getSecond();
			while (count > 0) {
				adaptor.implAdd(pair.getFirst());
				count--;
			}
		}
	}
	
	// this would take the elements and make the bag
	// if the elements are say from a list it just makes an unordered list
	// does this make sense?  how does it interact with the bag one above?
	
	public IMiniBagSinglesImplementation<K> makeBagSinglesAdaptor(
			IMiniCollection<? extends K> anotherCollection) {
		IMiniBagSinglesImplementation<K> adaptor = 
			new ImplJCBagSinglesHashMapAdaptor<K>();
		for (K k : anotherCollection) { adaptor.implAdd(k); }
		return adaptor;
		
	}
	
	
}
