package minicollection;


public interface IMiniBagSingles<K> 
			extends IMiniCollection<IMiniKeyValuePair<K,Integer>> {

	// aka sets!
	
	
	InsertCheck add(K key);      
    
	boolean removeOne(K key); // K not Object
	
	
	boolean removeAll(K key); // K not Object
	
	int uniqueKeySize(); // number of keys
	
	IMiniSequence<K> getKeys();
	
	// probably want to change to a set when I actually have one
	IMiniSequence<IMiniKeyValuePair<K, Integer>> getKeysAndCounts();
	
	
	IMiniBagSinglesIterator<K> bagIterator();
	
}
