package minicollection;

import java.util.ListIterator;

public class ImplJCSequenceIteratorAdaptor<E> 
					extends AbstractMiniSequenceIterator<E> {
	
	ListIterator<E> adaptee;
	
	public ImplJCSequenceIteratorAdaptor(ListIterator<E> it, E current) {
		super(current); 
		this.adaptee = it;
		
	}
	
	public boolean hasNext() { return adaptee.hasNext();}
    
	public boolean hasPrevious() { return adaptee.hasPrevious();}
	
	protected E primitive_next() { 
    	E ne = null;
    	if (adaptee.hasNext()) ne = adaptee.next();
	   	return ne;
    }
    
    protected void primitive_removeCurrent() {adaptee.remove();} 
    
    
    protected E primitive_previous() {
    	E pre = null;
    	if (adaptee.hasPrevious()) pre = adaptee.previous();
    	return pre;
}
    
		
}
